/*
 * Classe GamePlay: Classe construtora do game.
 */

package FugitiveBall;

import JPlay.Animation;
import JPlay.GameImage;
import JPlay.Keyboard;
import JPlay.Window;
import JPlay.Sound;
import JPlay.Time;
import java.awt.Color;
import java.awt.Font;


public class GamePlay {

    Window janela;
    GameImage fundo;
    Keyboard teclado;
    Bola bola;
    Inimigos cubo,cubo1,cubo2,cubo3,cubo4,cubo5, cubo6, cubo7, cubo8, finish;
    Muros muro, muro1, muro2,limite1,limite2, limite3, limite4;
    Animation explosao;
    Time tempo;
    int vidas;
    Font fonte;
    Sound musica;
    boolean executando = true, moverx = true, movery = true, moverx2 = true,
            movery2 = true, moverx3 = true, movery3 = true,
            subir = true, descer = true, direita = true, esquerda = true;
    boolean fimdejogo = false;

    public GamePlay(Window janela) {   // apagar parâmetro Window janela
        carregarObjetos(janela);
        posiçao();
        loop();
    }

    public void carregarObjetos(Window janela) {

        this.janela = janela;
        teclado = janela.getKeyboard();
        fundo = new GameImage("background.jpg");
        bola = new Bola("ball.png");
        cubo = new Inimigos("cubo.png");
        cubo1 = new Inimigos("cubo.png");
        cubo2 = new Inimigos("cubo.png");
        cubo3 = new Inimigos("cubo.png");
        cubo4 = new Inimigos("cubo.png");
        cubo5 = new Inimigos("cubo.png");
        cubo6 = new Inimigos("cubo.png");
        cubo7 = new Inimigos("cubo.png");
        cubo8 = new Inimigos("cubo.png");
        finish = new Inimigos ("final.png");
        limite1 = new Muros("limite.png");
        limite2 = new Muros("limite.png");
        limite3 = new Muros("limite2.png");
        limite4 = new Muros("limite2.png");
        muro = new Muros("muro.png");
        muro1 = new Muros("muro.png");
        muro2 = new Muros("muro.png");
        explosao = new Animation("explosao.png", 8);
        tempo = new Time(0, 1, 0, 134, 52,false);
        tempo.setColor(Color.white);
        tempo.setFont(new Font("century Gothic", Font.BOLD, 16));
        vidas = 5;
        fonte = new Font("century Gothic", Font.BOLD, 20);
        musica = new Sound("som.wav");
        musica.setRepeat(true);
        musica.play();
    }

    public void desenhar() {

        finish.draw();      // (por trás do jogo (invisível);
        limite1.draw();     // (por trás do jogo (invisível);
        limite2.draw();     // (por trás do jogo (invisível);
        limite3.draw();     // (por trás do jogo (invisível);
        limite4.draw();     // (por trás do jogo (invisível);
        fundo.draw();
        muro.draw();
        muro1.draw();
        muro2.draw();
        cubo.draw();
        cubo1.draw();
        cubo2.draw();
        cubo3.draw();
        cubo4.draw();
        cubo5.draw();
        cubo6.draw();
        cubo7.draw();
        cubo8.draw();
        bola.draw();
        tempo.draw();
        janela.drawText(Integer.toString(vidas), 730,50, Color.WHITE, fonte);
        janela.display();

    }

    public void posiçao() {

        explosao.x = bola.x;
        explosao.y = bola.y;
        bola.y =82;
        bola.x =20;
        cubo.y = 210;
        cubo.x = 20;
        cubo1.y = 360;
        cubo1.x = 200;
        cubo2.y = 500;
        cubo2.x = 200;
        cubo3.y = 82;
        cubo3.x = 390;
        cubo4.x = 410;
        cubo4.y = 330;
        cubo5.x = 595;
        cubo5.y = 540;
        cubo6.x = 635;
        cubo6.y = 330;
        cubo7.y = 290;
        cubo7.x = 290;
        cubo8.x = 730;
        cubo8.y = 190;
        muro.x = 200;
        muro.y = 83;
        muro1.x = 385;
        muro1.y = 290;
        muro2.x = 595;
        muro2.y = 83;
        limite1.x = 0;
        limite1.y = 78;
        limite2.x = 0;
        limite2.y = 585;
        limite3.x = 780;
        limite3.y = 0;
        limite4.x = 20;
        limite4.y = 0;
        finish.x = 730;
        finish.y = 83;

    }

    public void loop() {

        while (executando) {

            desenhar();
            bola.moveX(Keyboard.RIGHT_KEY, Keyboard.LEFT_KEY);
            bola.moveY(Keyboard.UP_KEY, Keyboard.DOWN_KEY);
            cubo.MoveXCubo();
            cubo1.MoveXCubo();
            cubo2.MoveyCubo2();
            cubo3.MoveyCubo3();
            cubo4.MoveyCubo4();
            cubo5.MoveyCubo5();
            cubo6.MoveyCubo6();
            cubo7.MoveyCubo7();
            cubo8.MoveyCubo8();

 // Aqui colisões com os muros.

            if (bola.collided(muro) == true) {
                if(bola.x<muro.x)
                    bola.x--;
                else
                    bola.x++;
            }

            if (bola.collided(muro1) == true) {
                if(bola.x<muro1.x)
                    bola.x--;
                else
                    bola.x++;
            }

               if (bola.collided(muro2) == true) {
                if(bola.x<muro2.x)
                    bola.x--;
                else
                    bola.x++;
            }

 // Aqui colisões com as laterais e superficies inferior e superior.

            if (bola.collided(limite1)==true)
                bola.y++;

            if (bola.collided(limite2)==true)
                bola.y--;

            if (bola.collided(limite3)==true)
                bola.x--;

            if (bola.collided(limite4)==true)
                bola.x++;

  // Aqui colisões com inimigos, cada colisão a vida decrementa 1 unidade.

            if ((bola.collided(cubo)==true)||(bola.collided(cubo1)== true)||
               (bola.collided(cubo2) == true )||(bola.collided(cubo3)== true)||
               (bola.collided(cubo4) == true )||(bola.collided(cubo5)== true)||
               (bola.collided(cubo6) == true )||(bola.collided(cubo7)== true)||
               (bola.collided(cubo8))== true)
             {
                new Sound("colidiu.wav").play(); //toca um som avisando:colidiu
                explosao.draw();
                janela.display();
                bola.x=20;  // bola volta ao inicio do jogo, decremetada de 1
                bola.y=80;
                vidas--;
             }

            if (tempo.timeEnded()) // Se tempo for = 0, o jogo termina
            {
                new Sound ("Colidiu.wav").play();
                executando = false;
            }


            if(bola.collided(finish)== true) // Aqui o jogador ganha o game.
            {
                musica.stop();
                executando = false;
                janela.toBack();

               Venceu jogo = new Venceu(janela); // chama a classe venceu
            }



            if (teclado.keyDown(Keyboard.ESCAPE_KEY) == true) {
                executando = false;
                janela.exit();
            }

            if (vidas == 0) {
                executando = false;
            }

        }

        if (fimdejogo == false) {  // Aqui o jogador perde
            musica.stop();
            Perdeu jogo = new Perdeu(janela); // chama a classe perdeu
            janela.toBack();
        }

    }
}